var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React from 'react';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTimeline' });
export function DTimeline(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dList, dVertical = false, dLineSize = 36 } = _a, restProps = __rest(_a, ["dList", "dVertical", "dLineSize"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const nodeExist = (() => {
        const hasNode = [false, false];
        for (const item of dList) {
            if (checkNodeExist(item.content[0])) {
                hasNode[0] = true;
            }
            if (checkNodeExist(item.content[1])) {
                hasNode[1] = true;
            }
        }
        return hasNode;
    })();
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}timeline`, {
            [`${dPrefix}timeline--vertical`]: dVertical,
        }) }, { children: dVertical ? (_jsx(_Fragment, { children: dList.map((item, index) => {
                const { content: itemContent, icon: itemIcon, status: itemStatus } = item;
                return (_jsxs(React.Fragment, { children: [_jsxs("div", Object.assign({ className: `${dPrefix}timeline__content` }, { children: [nodeExist[0] && (_jsx("div", Object.assign({ className: getClassName(`${dPrefix}timeline__text`, `${dPrefix}timeline__text--left`) }, { children: itemContent[0] }))), _jsxs("div", Object.assign({ className: getClassName(`${dPrefix}timeline__icon`, {
                                        [`is-${itemStatus}`]: itemStatus,
                                    }), style: { width: dLineSize } }, { children: [_jsx("div", { className: getClassName(`${dPrefix}timeline__separator`, {
                                                [`${dPrefix}timeline__separator--hidden`]: index === 0,
                                            }) }), checkNodeExist(itemIcon) ? itemIcon : _jsx("div", { className: `${dPrefix}timeline__dot` }), _jsx("div", { className: getClassName(`${dPrefix}timeline__separator`, {
                                                [`${dPrefix}timeline__separator--hidden`]: index === dList.length - 1,
                                            }) })] })), nodeExist[1] && _jsx("div", Object.assign({ className: `${dPrefix}timeline__text` }, { children: itemContent[1] }))] })), index !== dList.length - 1 && (_jsxs("div", Object.assign({ className: getClassName(`${dPrefix}timeline__content`, `${dPrefix}timeline__content--gap`) }, { children: [nodeExist[0] && _jsx("div", { className: getClassName(`${dPrefix}timeline__text`, `${dPrefix}timeline__text--left`) }), _jsx("div", Object.assign({ className: `${dPrefix}timeline__icon`, style: { width: dLineSize } }, { children: _jsx("div", { className: `${dPrefix}timeline__separator` }) })), nodeExist[1] && _jsx("div", { className: `${dPrefix}timeline__text` })] })))] }, index));
            }) })) : (_jsxs(_Fragment, { children: [nodeExist[0] && (_jsx("div", Object.assign({ className: `${dPrefix}timeline__text-container` }, { children: dList.map((item, index) => (_jsx("div", Object.assign({ className: `${dPrefix}timeline__text` }, { children: item.content[0] }), index))) }))), _jsx("div", Object.assign({ className: `${dPrefix}timeline__icon-container`, style: { height: dLineSize } }, { children: dList.map((item, index) => {
                        const { icon: itemIcon, status: itemStatus } = item;
                        return (_jsxs("div", Object.assign({ className: getClassName(`${dPrefix}timeline__icon`, {
                                [`is-${itemStatus}`]: itemStatus,
                            }) }, { children: [_jsx("div", { className: getClassName(`${dPrefix}timeline__separator`, {
                                        [`${dPrefix}timeline__separator--hidden`]: index === 0,
                                    }) }), checkNodeExist(itemIcon) ? itemIcon : _jsx("div", { className: `${dPrefix}timeline__dot` }), _jsx("div", { className: getClassName(`${dPrefix}timeline__separator`, {
                                        [`${dPrefix}timeline__separator--hidden`]: index === dList.length - 1,
                                    }) })] }), index));
                    }) })), nodeExist[1] && (_jsx("div", Object.assign({ className: `${dPrefix}timeline__text-container` }, { children: dList.map((item, index) => (_jsx("div", Object.assign({ className: `${dPrefix}timeline__text` }, { children: item.content[1] }), index))) })))] })) })));
}
